## 函数定义格式

- 主函数定义的格式:
  - int 代表函数执行之后会返回一个整数类型的值
  - main 代表这个函数的名字叫做main
  - () 代表这是一个函数
  - {} 代表这个程序段的范围
  - return 0; 代表函数执行完之后返回整数0

```c
int main() {
    // insert code here...
    return 0;
}
```

- 其它函数定义的格式
  - int 代表函数执行之后会返回一个整数类型的值
  - call 代表这个函数的名字叫做call
  - () 代表这是一个函数
  - {} 代表这个程序段的范围
  - return 0; 代表函数执行完之后返回整数0

```c
int call() {
    return 0;
}
```

---

## 如何执行定义好的函数

- 主函数(main)会由系统自动调用, 但其它函数不会, 所以想要执行其它函数就必须在main函数中手动调用
  - call 代表找到名称叫做call的某个东西
  - () 代表要找到的名称叫call的某个东西是一个函数
  - ;  代表调用函数的语句已经编写完成
  - 所以call();代表找到call函数, 并执行call函数

```c
int main() {
    call();
    return 0;
}
```

- 如何往屏幕上输出内容
  - 输出内容是一个比较复杂的操作, 所以系统提前定义好了一个专门用于输出内容的函数叫做printf函数,我们只需要执行系统定义好的printf函数就可以往屏幕上输出内容
  - 但凡需要执行一个函数, 都是通过函数名称+圆括号的形式来执行
  - 如下代码的含义是: 当程序运行时系统会自动执行main函数, 在系统自动执行main函数时我们手动执行了call函数和printf函数
  - 经过对代码的观察, 我们发现两个问题
    + 并没有告诉printf函数,我们要往屏幕上输出什么内容
    + 找不到printf函数的实现代码

```c
int call(){
    return 0;
}

int main(){
    call();
    printf();
    return 0;
}
```

- 如何告诉printf函数要输出的内容
  + 将要输出的内容编写到printf函数后面的圆括号中即可
  + 注意: 圆括号中编写的内容必须用双引号引起来

```c
printf("hello world\n");
```

- 如何找到printf函数的实现代码
  + 由于printf函数是系统实现的函数, 所以想要使用printf函数必须在使用之前告诉系统去哪里可以找到printf函数的实现代码
  + \#include <stdio.h> 就是告诉系统可以去stdio这个文件中查找printf函数的声明和实现

```c
#include <stdio.h>

int call(){
    return 0;
}

int main(){
    call();
    printf("hello world\n");
    return 0;
}
```

最后，如果你有任何学习疑问，可以加我微信 **leader_fengy** 拉你进学习群交流。