## 如何运行编写好的程序

- 方式1:
- 点击小榔头将"源代码"编译成"可执行文件"
- 找到编译后的源代码, 打开终端(CMD)运行可执行文件
  ![](https://img-blog.csdnimg.cn/img_convert/a5f93efcc499ec5ea5bcd9d338972c8a.png)
  ![](https://img-blog.csdnimg.cn/img_convert/a21ccb686fca0771cd10af728c270cd2.png)
  ![](https://img-blog.csdnimg.cn/img_convert/d7542b666e2558d47daf9cb7d631ddaf.png)
  ![](https://img-blog.csdnimg.cn/img_convert/4a8afead10db1343317a7368fb3042ca.png)
   ![](https://img-blog.csdnimg.cn/img_convert/0036733ed61b532efc2ef9907ba267bd.png)
- 方式2
- 直接点击Qt开发工具运行按钮
  ![](https://img-blog.csdnimg.cn/img_convert/97092b77d385d7f19e815f818dd0ec57.png)
  ![](https://img-blog.csdnimg.cn/img_convert/9d800a25ef0a1a9679b64a25de4b979b.png)

---

## main函数注意点及其它写法

- C语言中,每条完整的语句后面都必须以分号结尾

```c
int main(){
    printf("hello world\n") // 如果没有分号编译时会报错
    return 0;
}
```

```c
int main(){
    // 如果没有分号,多条语句合并到一行时, 系统不知道从什么地方到什么地方是一条完整语句
    printf("hello world\n") return 0;
}
```

- C语言中除了注释和双引号引起来的地方以外都不能出现中文

```c
int main(){
    printf("hello world\n"); // 这里的分号如果是中文的分号就会报错
    return 0;
}
```

- 一个C语言程序只能有一个main函数

```c
int main(){
    return 0;
}
int main(){ // 编译时会报错, 重复定义
    return 0;
}
```

- 一个C语言程序不能没有main函数

```c
int call(){ // 编译时报错, 因为只有call函数, 没有main函数
    return 0;
}
```

```c
int mian(){ // 编译时报错, 因为main函数的名称写错了,还是相当于没有main函数
    return 0;
}
```

- main函数前面的int可以不写或者换成void

```c
#include <stdio.h>
main(){ // 不会报错
    printf("hello world\n");
    return 0;
}
```

```c
#include <stdio.h>
void main(){  // 不会报错
    printf("hello world\n");
    return 0;
}
```

- main函数中的return 0可以不写

```c
int main(){ // 不会报错
    printf("hello world\n");
}
```

- 多种写法不报错的原因
  + C语言最早的时候只是一种规范和标准(例如C89, C11等)
  + 标准的推行需要各大厂商的支持和实施
  + 而在支持的实施的时候由于各大厂商利益、理解等问题,导致了实施的标准不同,发生了变化
    + Turbo C
    + Visual C(VC)
    + GNU C(GCC)
  + 所以大家才会看到不同的书上书写的格式有所不同, 有的返回int,有的返回void,有的甚至没有返回值
  + 所以大家只需要记住最标准的写法即可, no zuo no die

```c
#include <stdio.h>
int main(){
    printf("hello world\n");
    return 0;
}
```

>Tips: 
>语法错误：编译器会直接报错
>逻辑错误：没有语法错误，只不过运行结果不正确



最后，如果你有任何问题，欢迎加我微信 **leader_fengy** 拉你进学习交流群。